// version FrameBuffer/tinyptc

// writer font
int CHAR_W2=16;
int CHAR_H2=16;
#include "font1.h"
// sinus font
#include "fontsin.h"
int CHAR_W=48;
int CHAR_H=52;
int sinadd;

int pause = 0;   
int flagpause=0;      
int affichelogo=0;

unsigned char* ptfont=font1;
unsigned char* ptfont2=font2;

int textx,texty,lineptr=0,car=0; // writer et scroll simple

unsigned int copperlist[480];    

unsigned int pal[]={
0x770000,0x880000,0x990000,0xaa0000,0xbb0000,0xcc0000,0xdd0000,0xee0000,0xff0000,0xff1100, 
0xff2200,0xff3300,0xff4400,0xff5500,0xff6600,0xff7700,0xff8800,0xff9900,0xffaa00,0xffbb00,
0xffcc00,0xffdd00,0xffee00,0xffff00,0xeeff11,0xddff22,0xccff33,0xbbff44,0xaaff55,0x99ff66,
0x88ff77,0x77ff88,0x66ff99,0x55ffaa,0x44ffbb,0x55ffaa,0x66ff99,0x77ff88,0x88ff77,0x99ff66,
0xaaff55,0xbbff44,0xccff33,0xddff22,0xeeff11,0xffff00,0xffee00,0xffdd00,0xffcc00,0xffbb00,
0xffaa00,0xff9900,0xff8800,0xff7700,0xff6600,0xff5500,0xff4400,0xff3300,0xff2200,0xff1100,
0xff0000,0xee0000,0xdd0000,0xcc0000,0xbb0000,0xaa0000,0x990000,0x880000,0x770000
}; 

int asinTbl[360];

// writer for message box
void writeletter(int x,int y,int ch,int clr)
{
	int sx,sy,offset,txp=0,typ=0;

	offset=ch*(CHAR_W2*CHAR_H2)-(CHAR_W2*CHAR_H2);

	for(sy=0;sy<CHAR_H2;sy++)
	{
		txp=0;
		for(sx=0;sx<CHAR_W2;sx++)
		{
			if((x+txp)>=0 && (x+txp)<WIDTH)
				if(*(ptfont+offset+sx+(sy*CHAR_W2))>0)
				{
					buffer[x+txp+(y+typ)*WIDTH]=clr;
					if(ZOOM==2)
					{
						buffer[x+txp+1+(y+typ)*WIDTH]=clr;
						buffer[x+txp+1+(y+typ+1)*WIDTH]=clr;
						buffer[x+txp+(y+typ+1)*WIDTH]=clr;
					}
				}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}

float SINAMPL=44.5f;
float FREQ=0.01f;

// writer for sinuscroll
void writeletters(int x,int y,int ch,int clr)
{
	int sx,sy,offset,clr2;
	int txp=0,typ=0,sv;

	offset=ch*(CHAR_W*CHAR_H)-(CHAR_W*CHAR_H);

	for(sy=0;sy<CHAR_H;sy++)
	{
		txp=0;
		for(sx=0;sx<CHAR_W;sx++)
		{
//	        sv=(int)(40*ZOOM+asinTbl[(sinadd+x+txp)%360]); // sinus y pos
	        sv=(int)(40*ZOOM+asinTbl[(int)(((sinadd+x+txp)*0.5f))%360]); // sinus y pos

			if(((x+txp)>=0 && (x+txp)<WIDTH-1) && ((y+typ>0) && (y+typ<HEIGHT)))
			{
				if(*(ptfont2+offset+sx+(sy*CHAR_W))>0)
				{
					if(clr==0) clr2=copperlist[y+typ+sv]; else clr2=clr;
					buffer[x+txp+(y+typ+sv)*WIDTH]=clr2;
					if(ZOOM==2)
					{
						buffer[x+txp+1+(y+typ+sv)*WIDTH]=clr2;
						if(clr==0) clr2=copperlist[y+typ+sv+1]; else clr2=clr;
						buffer[x+txp+(y+typ+sv+1)*WIDTH]=clr2;
						buffer[x+txp+1+(y+typ+sv+1)*WIDTH]=clr2;
					}
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}

// -------------------------------------------- scrolltext horizontal simple (font1/2)
#ifdef SCROLLTXT

int scrollptr=0,scrollcount=0;

char scrtext[]="            "
"YOOOOOO!!!!!   VRS! PRESENTS --MIRACLE-- INTRO REMAKE !!!! "
"ORIGINAL CODE BY SABBATH. ORIGINAL SID MOD CALLED -ROMEO KNIGHT II-..."
"REMIX MODULE BY TIP. GFX FROM GAME SAVAGE - BYE... <=>        ";

char *ptscroll=scrtext;

int MP=0; 
int SCOFF=0;

void InitSinus(void)
{
	int i,b=0,c=0;
	float rad;

	for(i=(125-50);i<HEIGHT;i++)
	{
		copperlist[i]=pal[b];
		if(c==1)
		{
			b++;
			c=0;
		}else c=1;
		if(b==69) b=0;
	}


  /* create sin lookup table */
	for (i = 0; i < 360; i++)
	{
		rad =  (float)(i * PI/180); 
		asinTbl[i] =(int)(sin(rad) * SINAMPL);
	}
}


void DoScrollText(void)
{
	int i,car;
	sinadd+=5*ZOOM;
//	sinadd%=360;

	for(i=1;i<=8;i++)
	{
		car=*(ptscroll+i+MP)-31;
		writeletters((i*(CHAR_W*ZOOM+1))-SCOFF,(125-40)*ZOOM,car,RGB(0,0,0));
	}

	if(pause>0) pause--;

	if(pause==0)
	{
	SCOFF+=2*ZOOM;
	if(SCOFF>=(CHAR_W*2+1)*ZOOM)
	{
		SCOFF-=(CHAR_W+1)*ZOOM;
		MP++;
		if(*(ptscroll+MP+8)==0) MP=0;
//		if(MP>sizeof(scrtext)-21) MP=0;
	}
	}
}
#endif